struct POINTFLOAT 
{ 
float x;
float y;
};

struct GLYPHMETRICSFLOAT 
{
float gmfBlackBoxX;
float gmfBlackBoxY;
POINTFLOAT gmfptGlyphOrigin;
float gmfCellIncX;
float gmfCellIncY;
};




//--    GL 
struct glFont {

	GLYPHMETRICSFLOAT gmf[96];
//	GLYPHMETRICSFLOAT gmf[200];

	DWORD base;

        panViewOrtho();

	glFont(DWORD hDC, char *s);	//,  GL  
	
	printChar(char c, float lsx, float lsy, float lr, float tracking); 
	//                             

        //       
        float getWidth(char c, float tracking);

	float getHeight(char c); 

	print(DWORD lpString, float Xcoord, float Ycoord, float lsx, float lsy, float lr, float tracking); 
	//                                   
        ~glFont();

};



glFont::panViewOrtho() 
{
double WIDTH, HEIGHT; 

        GetClientRect(hWnd,#rcGL); 
        glViewport(0,0,rcGL.right,rcGL.bottom);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();


WIDTH=rcGL.right;
HEIGHT=rcGL.bottom;

	glOrtho(0.0, WIDTH, HEIGHT, 0.0, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

}



glFont::glFont(DWORD hDC, char *s)
{
DWORD font;

  	font = CreateFont(	12,			// Height Of Font
		0,					// Width Of Font
		0,					// Angle Of Escapement
		0,					// Orientation Angle
		900,					// Font Weight
		FALSE,					// Italic
		FALSE,					// Underline
		FALSE,					// Strikeout
		ANSI_CHARSET,				// Character Set Identifier
		OUT_TT_PRECIS,				// Output Precision
		CLIP_DEFAULT_PRECIS,			// Clipping Precision
		ANTIALIASED_QUALITY,			// Output Quality
		FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
		s);					// Font Name


	SelectObject(hDC, font);
	base = glGenLists(96);
//	base = glGenLists(200);

  wglUseFontOutlinesA(hDC, 32, 96, base,
//  wglUseFontOutlinesA(hDC, 32, 200, base,
//                         |      
//                              |- 
//                                  |    ,           base
		0.015f,							// Deviation From The True Outlines
		0.0f,							//       Z
		WGL_FONT_POLYGONS, #gmf);
		                                                        //


  DeleteObject(font);


}



glFont::printChar(char c, float lsx, float lsy, float lr, float tracking) 
{
float x, y, mx, my, xc;

  c -= 32;

x=DSFLOAT[sizeof(GLYPHMETRICSFLOAT)*c+#gmf.gmfBlackBoxX]; 
x=float x/2.0f;
mx=-x;


y=DSFLOAT[sizeof(GLYPHMETRICSFLOAT)*c+#gmf.gmfBlackBoxY];
y=float y/2.0f;
my=-y;



xc=DSFLOAT[sizeof(GLYPHMETRICSFLOAT)*c+#gmf.gmfCellIncX];
tracking=tracking+1.0f;
xc=xc*tracking;


glPushMatrix();
////    glTranslatef(gmf[c].gmfCellIncX/2.0f, gmf[c].gmfBlackBoxY/2.0f, 0);
glTranslatef(x, y, 0.0f);
glRotatef(lr, 0.0f, 0.0f, 1.0f);
glScalef(lsx, lsy, 1.0f);
////  glTranslatef(-gmf[c].gmfCellIncX/2.0f, -gmf[c].gmfBlackBoxY/2.0f, 0);
glTranslatef(mx, my, 0.0f);

glCallList(base+c);

glPopMatrix();	// Pops The Display List Bits

//  glTranslatef(gmf[c].gmfCellIncX*(tracking+1), 0, 0);
glTranslatef(xc, 0.0f, 0.0f);



}





float glFont::getWidth(char c, float tracking)
{
float xc;

  c -= 32;

//gmf[c-32].gmfCellIncX*(tracking+1);


xc=DSFLOAT[sizeof(GLYPHMETRICSFLOAT)*c+#gmf.gmfCellIncX];
tracking=tracking+1.0f;
xc=xc*tracking;
return xc;

}



float glFont::getHeight(char c)
{ 
//gmf[c-32].gmfBlackBoxY; 

float xc;
c -= 32;

xc=DSFLOAT[sizeof(GLYPHMETRICSFLOAT)*c+#gmf.gmfBlackBoxY];

return xc;
}



 glFont::print(DWORD lpString,  float Xcoord, float Ycoord, float lsx, float lsy, float lr, float tracking)
{
int l, i;
DWORD lpChar;
byte Symbol;
float dx, dy=0, Height, x, y;
float HeightSmall;



l=strlen(lpString); // 
lpChar=lpString;

  for(i = 0; i < l; i++)  {

    Symbol=DSBYTE[lpChar];

    dx += getWidth(Symbol, 0.0f);

//height = max(height, font.getHeight(text[i]));
    Height  = getHeight(Symbol); 
    if (Height>dy) dy=Height;


    lpChar++;

                          }

  x = dx/2.2f;  
  x = lsx/2.0f + x;

  y = dy/2.0f; 
  y = lsy/2.0f + y;

                           
    glPushMatrix();
//    glLoadIdentity();
    glTranslatef(Xcoord, Ycoord, 0.0f);


lpChar=lpString;
l=strlen(lpString);

loop(l)
	{

	Symbol=DSBYTE[lpChar];

	printChar(Symbol, lsx, lsy, lr, tracking);


	glTranslatef(x, 0.0f, 0.0f);


        y=-y;
        glTranslatef(0.0f, y, 0.0f);


	    lpChar++;
	

	y=-y;
        glTranslatef(0.0f, y, 0.0f);
        
	}


    glPopMatrix();	


}


glFont::~glFont() {
  glDeleteLists(base, 96);
}

//-----------------------------------------------------------------------------------------

